HDU3339实战:如何运用最短路和01背包问题解决算法?

更新于
2026-10-10 02:04:55
2阅读来源:SEO资源
  • 内容介绍
  • 文章标签
  • 相关推荐

本文共计1164个文字,预计阅读时间需要5分钟。

HDU3339实战:如何运用最短路和01背包问题解决算法?

时间限制:2000/1000 MS(Java/其他)内存限制:32768/32768 K(Java/其他)总提交次数:4189接受提交次数:1341题目描述:自1945年以来,自从曼哈顿计划首次爆炸核弹以来,...


In Action


Time Limit: 2000/1000 MS (Java/Others)Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4189Accepted Submission(s): 1341



Problem Description





Since 1945, when the first nuclear bomb was exploded by the Manhattan Project team in the US, the number of nuclear weapons have soared across the globe.


Nowadays,the crazy boy in FZU named AekdyCoin possesses some nuclear weapons and wanna destroy our world. Fortunately, our mysterious spy-net has gotten his plan. Now, we need to stop it.


But the arduous task is obviously not easy. First of all, we know that the operating system of the nuclear weapon consists of some connected electric stations, which forms a huge and complex electric network. Every electric station has its power value. To start the nuclear weapon, it must cost half of the electric network's power. So first of all, we need to make more than half of the power diasbled. Our tanks are ready for our action in the base(ID is 0), and we must drive them on the road. As for a electric station, we control them if and only if our tanks stop there. 1 unit distance costs 1 unit oil. And we have enough tanks to use.


Now our commander wants to know the minimal oil cost in this action.




Input


The first line of the input contains a single integer T, specifying the number of testcase in the file.
For each case, first line is the integer n(1<= n<= 100), m(1<= m<= 10000), specifying the number of the stations(the IDs are 1,2,3...n), and the number of the roads between the station(bi-direction).
Then m lines follow, each line is interger st(0<= st<= n), ed(0<= ed<= n), dis(0<= dis<= 100), specifying the start point, end point, and the distance between.
Then n lines follow, each line is a interger pow(1<= pow<= 100), specifying the electric station's power by ID order.




Output


The minimal oil cost in this action.
If not exist print "impossible"(without quotes).




Sample Input


2 2 3 0 2 9 2 1 3 1 0 2 1 3 2 1 2 1 3 1 3




Sample Output


5 impossible

HDU3339实战:如何运用最短路和01背包问题解决算法?




Author


Lost@HDU




Source


HDOJ Monthly Contest – 2010.03.06






第一次看见这个题目时时和ZMC作比赛,结果他AK了,我这个题看不懂,就这么过去了,复习最短路时又遇见了这次不能再错过了吧,又重新的看的题;

这是一个最短路+01背包的问题.

大体题意:是n个发电站,m条路,每条路有各自的距离,每个发电站有各自的发电量,现在需要炸毁它们,一辆坦克只能炸毁一个发电站,而且需要炸毁的发电厂的发电量需要大于所有发电站所产生的总电量的一半,求坦克走的最短距离。

因为题目说明不超过100个点,所以可以用弗洛伊德算法,把所有的0到各个发电站的距离找出来,然后把0能到的各个发电站的距离相加作为背包的容量,以dp数组储存的值作为炸毁的发电站的电量,最后进行判断,如果dp[i]的值大于所有发电站的总电量,输出i的值,此时i的值就是坦克炸毁发电站使城市供电瘫痪所能走的最短距离

#include<string.h> #include<stdlib.h> #include<stdio.h> #define INF 0x3f3f3f3f #define N 305 int map[N][N]; int n,m; int a[10010]; int dp[100001]; void floyd() { for(int k=0;k<=n;k++) { for(int i=0;i<=n;i++) { for(int j=0;j<=n;j++) { if(map[i][j] > map[i][k]+map[k][j]) { map[i][j] = map[i][k] + map[k][j]; } } } } } int main() { int T; scanf("%d",&T); while(T--) { scanf("%d%d",&n,&m); for(int i=0; i<=n; i++) { for(int j=0; j<=n; j++) { map[i][j] = INF; } map[i][i] = 0; } int x,y,z; for(int i=0; i<m; i++) { scanf("%d%d%d",&x,&y,&z); if(map[x][y]>z) { map[x][y] = z; map[y][x] = z; } } floyd(); int sum = 0; int count = 0; for(int i=1; i<=n; i++) { scanf("%d",&a[i]); sum += a[i]; if(map[0][i] != INF) { count += map[0][i]; } } memset(dp,0,sizeof(dp)); for(int i=1;i<=n;i++) { for(int j=count;j>=map[0][i];j--) { if(dp[j-map[0][i]] + a[i] > dp[j]) { dp[j] = dp[j-map[0][i]] + a[i]; } } } int flag = 0; for(int i=1;i<=count;i++) { if(dp[i] > sum/2.0) { flag = 1; printf("%d\n",i); break; } } if(flag == 0) { printf("impossible\n"); } } return 0; }





本文共计1164个文字,预计阅读时间需要5分钟。

HDU3339实战:如何运用最短路和01背包问题解决算法?

时间限制:2000/1000 MS(Java/其他)内存限制:32768/32768 K(Java/其他)总提交次数:4189接受提交次数:1341题目描述:自1945年以来,自从曼哈顿计划首次爆炸核弹以来,...


In Action


Time Limit: 2000/1000 MS (Java/Others)Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4189Accepted Submission(s): 1341



Problem Description





Since 1945, when the first nuclear bomb was exploded by the Manhattan Project team in the US, the number of nuclear weapons have soared across the globe.


Nowadays,the crazy boy in FZU named AekdyCoin possesses some nuclear weapons and wanna destroy our world. Fortunately, our mysterious spy-net has gotten his plan. Now, we need to stop it.


But the arduous task is obviously not easy. First of all, we know that the operating system of the nuclear weapon consists of some connected electric stations, which forms a huge and complex electric network. Every electric station has its power value. To start the nuclear weapon, it must cost half of the electric network's power. So first of all, we need to make more than half of the power diasbled. Our tanks are ready for our action in the base(ID is 0), and we must drive them on the road. As for a electric station, we control them if and only if our tanks stop there. 1 unit distance costs 1 unit oil. And we have enough tanks to use.


Now our commander wants to know the minimal oil cost in this action.




Input


The first line of the input contains a single integer T, specifying the number of testcase in the file.
For each case, first line is the integer n(1<= n<= 100), m(1<= m<= 10000), specifying the number of the stations(the IDs are 1,2,3...n), and the number of the roads between the station(bi-direction).
Then m lines follow, each line is interger st(0<= st<= n), ed(0<= ed<= n), dis(0<= dis<= 100), specifying the start point, end point, and the distance between.
Then n lines follow, each line is a interger pow(1<= pow<= 100), specifying the electric station's power by ID order.




Output


The minimal oil cost in this action.
If not exist print "impossible"(without quotes).




Sample Input


2 2 3 0 2 9 2 1 3 1 0 2 1 3 2 1 2 1 3 1 3




Sample Output


5 impossible

HDU3339实战:如何运用最短路和01背包问题解决算法?




Author


Lost@HDU




Source


HDOJ Monthly Contest – 2010.03.06






第一次看见这个题目时时和ZMC作比赛,结果他AK了,我这个题看不懂,就这么过去了,复习最短路时又遇见了这次不能再错过了吧,又重新的看的题;

这是一个最短路+01背包的问题.

大体题意:是n个发电站,m条路,每条路有各自的距离,每个发电站有各自的发电量,现在需要炸毁它们,一辆坦克只能炸毁一个发电站,而且需要炸毁的发电厂的发电量需要大于所有发电站所产生的总电量的一半,求坦克走的最短距离。

因为题目说明不超过100个点,所以可以用弗洛伊德算法,把所有的0到各个发电站的距离找出来,然后把0能到的各个发电站的距离相加作为背包的容量,以dp数组储存的值作为炸毁的发电站的电量,最后进行判断,如果dp[i]的值大于所有发电站的总电量,输出i的值,此时i的值就是坦克炸毁发电站使城市供电瘫痪所能走的最短距离

#include<string.h> #include<stdlib.h> #include<stdio.h> #define INF 0x3f3f3f3f #define N 305 int map[N][N]; int n,m; int a[10010]; int dp[100001]; void floyd() { for(int k=0;k<=n;k++) { for(int i=0;i<=n;i++) { for(int j=0;j<=n;j++) { if(map[i][j] > map[i][k]+map[k][j]) { map[i][j] = map[i][k] + map[k][j]; } } } } } int main() { int T; scanf("%d",&T); while(T--) { scanf("%d%d",&n,&m); for(int i=0; i<=n; i++) { for(int j=0; j<=n; j++) { map[i][j] = INF; } map[i][i] = 0; } int x,y,z; for(int i=0; i<m; i++) { scanf("%d%d%d",&x,&y,&z); if(map[x][y]>z) { map[x][y] = z; map[y][x] = z; } } floyd(); int sum = 0; int count = 0; for(int i=1; i<=n; i++) { scanf("%d",&a[i]); sum += a[i]; if(map[0][i] != INF) { count += map[0][i]; } } memset(dp,0,sizeof(dp)); for(int i=1;i<=n;i++) { for(int j=count;j>=map[0][i];j--) { if(dp[j-map[0][i]] + a[i] > dp[j]) { dp[j] = dp[j-map[0][i]] + a[i]; } } } int flag = 0; for(int i=1;i<=count;i++) { if(dp[i] > sum/2.0) { flag = 1; printf("%d\n",i); break; } } if(flag == 0) { printf("impossible\n"); } } return 0; }